
/*----------------------------------------------------------------
   Copyright (c) Quinn-Curtis, 1993

   Filename:  ASYNC2.H
   Revision:  8.03
   Date:      4/1/92

   Description: -Prototypes for asynchronous communications
-------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef COM_1
#define COM_1       0  /* Com port 1 */
#define COM_2       1  /* Com port 2 */
#define ERR_NONE    0  /* No errors */
#define ERR_COM     1  /* Com port number error */
#define	ERR_BAUD    2  /* baud rate error */
#define	ERR_PARITY  3  /* parity error */
#define	ERR_STOP    4  /* stop bits error */
#define	ERR_WORD    5  /* world length error */
#define ERR_CHAR	6  /* no characters available */
#define	ERR_BUFF	7  /* buffer overflow */
#define ERR_TIME    8  /* time out */
#define ERR_MAXSTR  9  /* max string length */
#define ERR_INIT    10  /* com port not initialized */
#define HND_NONE	0  /* No handshaking */
#define	HND_HARD	1  /* hardware handshake */
#define	HND_SOFT	2  /* software handshake */
#define PAR_NONE	0  /* No parity*/
#define	PAR_EVEN	1  /* even parity*/
#define	PAR_ODD	 	3  /* odd parity*/
#endif

void setcombase(int cport, int cbase, int cintr);
void sethandshakemode(int cport, int hsmode);
void sethardhandshake(int cport, int hs);
void setxchars(int cport, char xon, char xoff);
void setbuffervars(int cport,int maxbuf,int nfull, int nempty);
void resetbuffer(int cport);
void clear_buffer(int cport);/*CP 4/18/2000*/
void setserial(int cport,int baudrate);
int checkhandshake(int cport);
void sendcom (int cport,char c, int *errcode);
void opencom (int comport, int baud, int parity, int stopbits,
		 int numbits, int *errcode);
void closecom (int cport);
void checkcom (int cport, char *c, int *errcode);
void writecom (int cport, char *s, int *errcode);
void writelncom (int cport, char *s, int *errcode);
void readlncom (int cport, char *s, int *errcode);

#ifdef __cplusplus
}
#endif
