/***************************************************************************
	(C) COPYRIGHT 1999,2000,2001 by JANOS TECHNOLOGY INC. Townshend Vermont
	PROPRIETARY: Source code, algorithms and data contained in this
				 file may not be used, reproduced or transmitted
				 without written permission of JANOS TECHNOLOGY INC.

		 PROJECT: HGM300
		  AUTHOR: Chris Prozzo

***************************************************************************/

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dir.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include "culproto.h"
#include "pc2hgm.h"


/*............................LOCAL FUNCTIONS.............................*/

int overwrite();
int file_select(int row,int col,char *search_path,char *selected_file);
int disk_error(int error_code);
void dir();

/*............................LOCAL VARIABLES.............................*/

char config_file_name[MAXFILE]= {"startup"}; /* name of configuration file */
char full_path[MAXPATH], /* strings for parseing path */
	 drive[MAXDRIVE],
	 directory[MAXDIR],
	 file_name[MAXFILE],
	 ext[MAXEXT];
char file_id[12] = {"JTI-CVFDC\0"};

/*...........................EXTERNAL FUNCTIONS...........................*/


/*..........................EXTERNAL VARIABLES............................*/


/*.............................INITIALIZE PATH............................*/
/* Gets current drive and path parses its components into strings and     */
/* trys to load startup.cfg file from the current directory               */

void path_init()
{
	int len;
	getcwd(full_path,MAXPATH);
	len = strlen(full_path) - 1;
	if (full_path[len] != 92) full_path[len+1] = 92;
	fnsplit(full_path,drive,directory,file_name,ext);
	return;
}

/*........................WRITE CONFIGURATION TO DISK......................*/
/* Stores current configuration data in active directory under user        */
/* supplied name with .cfg extension                                       */

void write_config()
{

	int error;
	int i;
	unsigned num_written;
	unsigned handle;

	fnmerge(full_path,drive,directory,config_file_name,".cfg"); /* build full path */
	if (filexist(full_path)) /* if file allready exists warn of overwrite */
	{
		if ((overwrite()) == 1) return;
	}
	_fmode = O_BINARY; /* set file type to binary */
	do
	{
		error = creatfil(full_path,0x20,&handle);
		if (error != 0 && (disk_error(error)) == 1)
			return;
	} while(error != 0);

	writefil(handle,sizeof(HGM_SYSTEM_DATA),(char *)&HGM,&num_written);
	writefil(handle,sizeof(HGM_ZONE_TYPE)*16,(char *)&zone,&num_written);
	writefil(handle,sizeof(HGM_CAL_TYPE),(char *)&HGM_cal,&num_written);
	writefil(handle,sizeof(HGM_FAULT_LOG_TYPE),(char *)&HGM_fault_log,&num_written);
	writefil(handle,sizeof(HGM_SENSOR_DATA),(char *)&sensor,&num_written);
	writefil(handle,sizeof(HGM_STATUS_DATA),(char *)&HGM_status,&num_written);

	closefil(handle);
	return;
}

/*........................SAVE CONFIGURATION DATA.........................*/
/*  Prompts user for 8 charecter file name to store configuration data    */
/*  under then calls write_config to write it to the current directory    */

void save_config()
{
	DLG_PTR dlg_ptr;
	char name[9];
	int col=25, row=3, return_val;

	mouse_off();
	dlg_ptr = dlg_open(row,col,row+2,col+35,-1,pop_menu_fg,pop_menu_bk,pop_menu_fg,pop_menu_bk);
	dlg_loc(dlg_ptr,0,0);
	dlg_prnt(dlg_ptr,"Save current config as >",pop_menu_fg,pop_menu_bk,0);
	dlg_loc(dlg_ptr,0,25);
	dlg_prnt(dlg_ptr,"        ",user_input_fg,user_input_bk,0);
	dlg_loc(dlg_ptr,0,25);
	curon();
	return_val = getcstr(8,1,27,1,2,name,1); /* get 8 charecter string */
	curoff();
	mouse_on();
	if (return_val == 13 && strlen(name)>0) /* if valid data entered */
	{
		strcvt(config_file_name,name,1); /*remove all blanks*/
		write_config(); /* write configuration to disk */
	}
	mouse_off();
	dlg_clos(dlg_ptr);
	mouse_on();
	kybdstuf("f");
	return;
}

/*........................WRITE TREND DATA TO DISK.........................*/
/* Stores trend data to comma deliminted text file                         */
/* supplied name with .txt extension                                       */

void write_trend()
{

	int error;
	int i;
	unsigned num_written;
	unsigned handle;
	char crlf[2]={13,10};

	fnmerge(full_path,drive,directory,config_file_name,".txt"); /* build full path */
	if (filexist(full_path)) /* if file allready exists warn of overwrite */
	{
		if ((overwrite()) == 1) return;
	}
	_fmode = O_TEXT; /* set file type to binary */
	do
	{
		error = creatfil(full_path,0x20,&handle);
		if (error != 0 && (disk_error(error)) == 1)
			return;
	} while(error != 0);

	for(i=0;i<100;i++)
	{
		writefil(handle,25,trend_string_ptr[i],&num_written);
		writefil(handle,2,crlf,&num_written);
	}

	closefil(handle);
	return;
}
/*........................SAVE TREND DATA.................................*/
/*  Prompts user for 8 charecter file name to store configuration data    */
/*  under then calls write_trend to write it to the current directory    */

void save_trend()
{
	DLG_PTR dlg_ptr;
	char name[9];
	int col=25, row=3, return_val;

	mouse_off();
	dlg_ptr = dlg_open(row,col,row+2,col+32,-1,pop_menu_fg,pop_menu_bk,pop_menu_fg,pop_menu_bk);
	dlg_loc(dlg_ptr,0,0);
	dlg_prnt(dlg_ptr,"Save Trend data as >",pop_menu_fg,pop_menu_bk,0);
	dlg_loc(dlg_ptr,0,22);
	dlg_prnt(dlg_ptr,"        ",user_input_fg,user_input_bk,0);
	dlg_loc(dlg_ptr,0,22);
	curon();
	return_val = getcstr(8,1,27,1,2,name,1); /* get 8 charecter string */
	curoff();
	mouse_on();
	if (return_val == 13 && strlen(name)>0) /* if valid data entered */
	{
		strcvt(config_file_name,name,1); /*remove all blanks*/
		write_trend(); /* write trend to disk */
	}
	mouse_off();
	dlg_clos(dlg_ptr);
	mouse_on();
	return;
}
/*...........................CHOOSE CONFIG FILE............................*/
/* Calls file_select to find and lists to screen window all files with a   */
/* .cfg extension in the current directory allows user to select with mouse*/
/* or arrow keys and if a valid selection is made calls get_config to read */
/* data from the file                                                      */

void choose_config()
{
	int result;
	int col=30, row=3; /* location of file select window */
	char selection_name[13];

	delay(200);
	fnmerge(full_path,drive,directory,"*",".cfg");
	result = file_select(row,col,full_path,selection_name);
	if (result != 1) /* no file selected */
	{
		kybdstuf("f");
		return;
	}
	sscanf(selection_name,"%[^.]",config_file_name); /* store selection name */
	get_config(selection_name);  /* read data in */
	put_system_data();
	put_status_data();
	put_zone_data();
	kybdstuf("f");
	return;
}

/*......................GET CONFIGURATION DATA FROM DISK...................*/
/*  Reads configuration data from file selected in choose_config           */

void get_config(char *config_file)
{
	int i;
	unsigned handle;
	unsigned num_read;

	fnmerge(full_path,drive,directory,config_file,NULL);
	_fmode = O_BINARY;
	if ((openfil(full_path,0,&handle)) == 0)
	{
		readfil(handle,sizeof(HGM_SYSTEM_DATA),(char *)&HGM,&num_read);
		readfil(handle,sizeof(HGM_ZONE_TYPE)*16,(char *)&zone,&num_read);
		readfil(handle,sizeof(HGM_CAL_TYPE),(char *)&HGM_cal,&num_read);
		readfil(handle,sizeof(HGM_FAULT_LOG_TYPE),(char *)&HGM_fault_log,&num_read);
		readfil(handle,sizeof(HGM_SENSOR_DATA),(char *)&sensor,&num_read);
		readfil(handle,sizeof(HGM_STATUS_DATA),(char *)&HGM_status,&num_read);
		closefil(handle);
	}
	return;
}


/*.............................FILE SELECT................................ */
/* Searches current directory with filespec arguments then lists all       */
/* matches to a window at col,row and allow user to select one with mouse  */
/* or arrow keys and returns the selected file name                        */

int file_select(int row,int col,char *search_path,char *selected_file)
{

	int  disp_num=15,num_found,startno=0,max_files = 100, return_val,i;
	char *buffer; /* memory buffer */
	char *ret_arr[100]; /* pointers to strings in buffer */
	char fname[14],ext[4],title[26];
	DLG_PTR dlg_ptr;

	buffer=(char *)malloc(6500);
	if(buffer == NULL)
	{
		out_of_memory();
		return(0);
	}
	findfile(search_path,max_files,startno,ret_arr,buffer,&num_found,0);
	if (num_found < disp_num)
		disp_num = num_found;
	if (num_found > 0)
	{
		for(i=0;i<=num_found-1;i++)
		{
			fnsplit(ret_arr[i],NULL,NULL,fname,ext);
			strcat(fname,ext);
			strcpy(ret_arr[i],fname);
		}
		mouse_on();
		if(strlen(search_path) >25)
			strright(search_path,title,strlen(search_path)-24,25);
		else
			strcpy(title,search_path);
		return_val = scrlmenu(row,col,ret_arr,num_found,disp_num,pop_menu_fg,pop_menu_bk,-1,title,0,NULL);
		if (return_val == -1)
		{
			free(buffer);
			return(0);
		}
		strleft(ret_arr[return_val],selected_file,12,13);
		free(buffer);
		return(1);
	 }
		mouse_off();
		dlg_ptr = dlg_open(row,col,row+2,col+17,-1,dlgbox_fg,dlgbox_bk,border_fg,border_bk);
		dlg_loc(dlg_ptr,0,0);
		dlg_prnt(dlg_ptr," No files found ",dlgbox_fg,dlgbox_bk,0);
		shrtbeep();
		delay(2000);
		dlg_clos(dlg_ptr);
		free(buffer);
		put_system_data();
		put_status_data();
		put_zone_data();
		return(0);
}



/*................................SET PATH.................................*/
/* Opens window for user modification of current path                      */

void set_path()
{
	int return_val, len;
	char temp_path[80];
	DLG_PTR dlg_ptr;

	fnmerge(temp_path,drive,directory,NULL,NULL);
	dlg_ptr = dlg_open(3,3,5,44,-1,pop_menu_fg,pop_menu_bk,pop_menu_fg,pop_menu_bk);
	dlg_loc(dlg_ptr,0,0);
	dlg_prnt(dlg_ptr," Current path = ",pop_menu_fg,pop_menu_bk,0);
	dlg_loc(dlg_ptr,0,16);
	curon();
	return_val = getscrl(58,0,1,27,1,2,temp_path,1,user_input_fg,user_input_bk,23);
	curoff();
	if (return_val == 13 && strlen(temp_path)>1)
	{
		len = strlen(temp_path) - 1;
		if (temp_path[len] != 92) strcat(temp_path,"\\");
		fnsplit(temp_path,drive,directory,NULL,NULL);
		fnmerge(full_path,drive,directory,NULL,NULL);
	}
	dlg_clos(dlg_ptr);
	kybdstuf("f");
	return;
}





/*.......................FILE EXISTS, OVERWRITE?...........................*/

int overwrite()
{
	int return_val;
	char *msg[] = {"  FILE EXISTS, OVERWRITE ?",
				   " ",
				   " change file name to prevent",
				   "  overwriting existing file"};
	delay(200);
	return_val = dlg_answ(0,4,24,-1,dlgbox_fg,dlgbox_bk,main_menu_fg,main_menu_bk,msg,4);
	return(return_val);

}

/*...........................DISK ERROR HANDLER............................*/

int disk_error(int error_code)
{
	int return_val;
	char *msg[1] = {"    DISK ERROR, CONTINUE ?"};

	return_val =dlg_answ(0,4,24,-1,dlgbox_fg,dlgbox_bk,main_menu_fg,main_menu_bk,msg,1);
	return(return_val);
}

/*...............................DIRECTORY.................................*/

void dir()
{
	int result, col=3, row=3;
	char selection_name[13];

	fnmerge(full_path,drive,directory,"*.*",NULL);
	delay(200);
	result = file_select(row,col,full_path,selection_name);
	kybdstuf("f");
	return;

}

/*............................DOS ERROR HANDLER............................*/

/*..............................OUT OF MEMORY..............................*/

void out_of_memory()
{
	DLG_PTR dlg_ptr;

	mouse_off();
	dlg_ptr = dlg_open(4,25,6,49,-1,dlgbox_fg,dlgbox_bk,dlgbox_fg,dlgbox_bk);
	dlg_loc(dlg_ptr,0,0);
	dlg_prnt(dlg_ptr," INSUFFICIENT MEMORY ! ",dlgbox_fg,dlgbox_bk,0);
	longbeep();
	delay(3000);
	dlg_clos(dlg_ptr);
	mouse_on();
	return;
}

/*..........................INCOMPLETE DATA SET.............................*/
void job_incomplete()
{
	DLG_PTR dlg_ptr;

	mouse_off();
	dlg_ptr = dlg_open(4,25,6,49,-1,dlgbox_fg,dlgbox_bk,dlgbox_fg,dlgbox_bk);
	dlg_loc(dlg_ptr,0,0);
	dlg_prnt(dlg_ptr," INCOMPLETE JOB DATA  ! ",dlgbox_fg,dlgbox_bk,0);
	longbeep();
	delay(3000);
	dlg_clos(dlg_ptr);
	mouse_on();
	return;
}

