/***************************************************************************
	(C) COPYRIGHT 1999,2000,2001 by JANOS TECHNOLOGY INC. Townshend Vermont
	PROPRIETARY: Source code, algorithms and data contained in this
				 file may not be used, reproduced or transmitted
				 without written permission of JANOS TECHNOLOGY INC.

		 PROJECT: HGM300
		  AUTHOR: Chris Prozzo

***************************************************************************/

#define MAIN


#include <stdio.h>
#include <conio.h>
#include "culproto.h"
#include "async2.h"
#include "pc2hgm.h"


/*.........................LOCAL VARIABLES...............................*/

int mono;

/*.........................LOCAL FUNCTIONS................................*/

void var_init();
void set_colors(int mono);
void get_date();
void install_mouse();

/*........................EXTERNAL FUNCTIONS..............................*/

void set_menu_colors();

/*..............................M A I N...................................*/
// Comand line arguments are 'm' for mono display, 's' for service mode
// and '2' for com2 instead of com1 */

main(int argc, char **argv)
{

	if(argv[1][0] == 'm' || argv[1][0] == 'M')
		mono=YES;
	else
		mono=NO;
	if(argv[1][0] == 's' || argv[1][0] == 'S' || argv[2][0] == 's' || argv[2][0] == 'S')
		in_service_mode=YES;
	else
		in_service_mode=NO;
	clrscr();
	qvideo();  /* set quick video option */
	curoff();
	get_date();
	install_mouse();
	var_init(); /* intialize globals to default values */
	setbac16(1);
	set_colors(mono);  /* check for mono or color monitor and set colors apropriately */
	diskstat(0); /* enable disk error trapping */

	/* build main screen */
	put_system_box();
	put_zone_box();
	if(argv[1][0]=='2' || argv[1][1]=='2')
		open_com(COM_2);
	else
		open_com(COM_1);
	get_HGM_parameters();
	main_menu();
	return(0);
}



/*..................INITIALIZE VARIABLES TO DEFAULT VALUES.................*/
/* Sets globals to default values, these are overridden by the startup.cfg */
/* file if it exists.                                                      */

void var_init()
{
	int z;
	sound_status = ON;
	help = OFF;
	path_init(); /* get and parse current path */
	for(z=0;z<16;z++)
		zone[z].refrigerant_type=R134A;
}




/*...............................SET COLORS................................*/

void set_colors(int mono)
{
	struct text_info ti;
	gettextinfo(&ti); /* check if in color mode */
	if (ti.currmode == C80 && mono == NO)
	{
		msg_fg=YELLOW;
		msg_bk=RED;
		border_fg=YELLOW;
		border_bk=RED;
		title_fg=YELLOW;
		title_bk=BLACK;
		main_menu_fg = LTCYAN;
		main_menu_bk = BLUE;
		highlight_fg = YELLOW;
		highlight_bk = MAGENTA;
		pop_menu_fg = YELLOW;
		pop_menu_bk = MAGENTA;
		dlgbox_fg = YELLOW;
		dlgbox_bk = BLUE;
		user_input_fg = YELLOW;
		user_input_bk = BLACK;
		help_fg = BLACK;
		help_bk = LTCYAN;
	}
	else
	{
		msg_fg=BLACK;
		msg_bk=WHITE;
		border_fg=BLACK;
		border_bk=WHITE;
		title_fg=WHITE;
		title_bk=BLACK;
		main_menu_fg = WHITE;
		main_menu_bk = BLACK;
		highlight_fg = BLACK;
		highlight_bk = WHITE;
		pop_menu_fg = BLACK;
		pop_menu_bk = WHITE;
		dlgbox_fg = BLACK;
		dlgbox_bk = WHITE;
		user_input_fg = BLACK;
		user_input_bk = WHITE;
		help_fg = BLACK;
		help_bk = WHITE;
	}
	set_menu_colors();


}





/*.............................GET DATE....................................*/

void get_date()
{

	sysdate(date_string,3);
	return;
}



/*.............................INSTALL MOUSE...............................*/

void install_mouse()
{
	if (m_instal() == -1)
	{	mouse = esimouse = 1; m_setcur(0,0); m_curoff();}
	else
	{ mouse = esimouse = 0; }
	return;
}




