/***************************************************************************
	(C) COPYRIGHT 1999,2000,2001 by JANOS TECHNOLOGY INC. Townshend Vermont
	PROPRIETARY: Source code, algorithms and data contained in this
				 file may not be used, reproduced or transmitted
				 without written permission of JANOS TECHNOLOGY INC.

		 PROJECT: AGM300
		  AUTHOR: Chris Prozzo

***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <math.h>
#include "comports.h"
#include "culproto.h"
#include "pc2hgm.h"



/*...........................LOCAL FUCNTIONS...............................*/

int get_string(int col,int row,int len,char *str,char *fmt);
int get_float(int row,int col,int left,int right,float *f,float min,float max,char *fmt);
int get_integer(int row,int col,int len,int *num,int min,int max);
int get_un_integer(int row,int col,int len,unsigned int *num,unsigned int min,unsigned int max);
int edit_file_name();
/*.............................EXTERNAL FUNCTIONS...........................*/

int put_message(DLG_PTR *box_ptr,char *message,int row,int col);
int send_HGM_time(TRANSMIT_TIME_TYPE *t);

/*.........................................................................*/
char *rs485_baud_str[]={"0","110","150","300","600","1200","2400",
				   "4800","9600","19200","31250","62500","125000",
				   "250000"};
char *rs232_baud_str[14]={"0","55","110","150","300","600","1200","2400","4800",
						 "9600","19200","38400","57600","115200"};
char *dis_en_str[2]={"DISABLED","ENABLED"};
char *alarm_type_str[4]={"NO ALARM","LEAK","SPILL","EVACUATE"};
char *relay_parameter_str[7]={"UNUSED","ALARM","FAULT","LEAK","SPILL","EVACUATE","MONITOR ON"};
char *rezero_str[2]={"AUTO","ZONE CHNG"};
char *manual_auto_str[2]={"MANUAL","AUTO"};
char *mode_str[]={"SCANNING","HOLDING","DIAGNOSTIC","SERVICE"};
char *state_str[]={"IDLE","SAMPLING","PURGING","WARM UP","PRESSURE CHK"};
char *installed_str[]={"NOT INSTALLED","INSTALLED"};
char *refrigerant_name[]={"R11","R12","R22","R23","R113",
						  "R114","R123","R124","NH3","R401A",
						  "R402A","R402B","R404A","R407A","R407C",
						  "R409A","R410A","R500","R502","R503",
						  "R507","R508B","H1301","R408A","FUTURE2",
						  "FUTURE3","FUTURE4","FUTURE5","FUTURE6","FUTURE7",
						  "NEW GAS1","NEW GAS2","NEW GAS3"};
//...........................................................................
extern int port;

/*.........................GET A STRING AT ROW COL.........................*/

int get_string(int row,int col,int len,char *str,char *fmt)
{
	int return_val;
	char temp_str[80];

	paint(row,col,row,col+len,user_input_fg,user_input_bk);
	curlocat(row,col);
	kybdstuf(str);
	curon();
	return_val = getcstr(len,1567,27,0,2,temp_str,1);
	curoff();
	if (return_val != ESCAPE && return_val > 0)
		strcpy(str,temp_str);
	paint(row,col,row,col+len,text_fg,text_bk);
	curlocat(row,col);
	colrprtf(0,text_fg,text_bk,fmt,str);
	return(return_val);
}

/*.......................GET FLOAT AT ROW COL..............................*/

int get_float(int row,int col,int left,int right,float *f,float min,float max,char *fmt)
{
	int return_val;
	float temp;
	char f_str[20];


	curlocat(row,col);
	paint(row,col,row,col+left+right,user_input_fg,user_input_bk);
	curlocat(row,col);
	if (*f>0.00){
		sprintf(f_str,fmt,*f);
		kybdstuf(f_str);
	}
	curon();
	return_val = getfloat(left,right,1663,27,0,2,&temp,1,min,max);
	curoff();
	if (return_val != ESCAPE && return_val > 0)
		*f = temp;
	paint(row,col,row,col+left+right,text_fg,text_bk);
	return(return_val);
}


/*......................GET INT AT ROW COL..................................*/

int get_integer(int row,int col,int len,int *num,int min,int max)
{
	int return_val;
	int temp;
	char num_str[10];

	curlocat(row,col);
	paint(row,col,row,col+len-1,user_input_fg,user_input_bk);
	curlocat(row,col);
	if(*num >0){
		sprintf(num_str,"%d",*num);
		kybdstuf(num_str);
	}
	curon();
	return_val = getint(len,1663,27,0,2,&temp,1,min,max);
	curoff();
	if (return_val != ESCAPE && return_val > 0)
		*num=temp;
	paint(row,col,row,col+len-1,text_fg,text_bk);
	return(return_val);
}

/*......................GET UNINT AT ROW COL..................................*/

int get_un_integer(int row,int col,int len,unsigned int *num,unsigned int min,unsigned int max)
{
	int return_val;
	unsigned int temp;
	char num_str[10];

	curlocat(row,col);
	paint(row,col,row,col+len-1,user_input_fg,user_input_bk);
	curlocat(row,col);
	sprintf(num_str,"%0*u",len,*num);
	kybdstuf(num_str);
	curon();
	return_val = getunint(len,1663,27,0,2,&temp,1,min,max);
	curoff();
	if (return_val != ESCAPE && return_val > 0)
		*num=temp;
	paint(row,col,row,col+len-1,text_fg,text_bk);
	return(return_val);
}
/*......................GET UN CHAR AT ROW COL..................................*/

int get_un_char(int row,int col,int len,unsigned char *num,unsigned char min,unsigned char max)
{
	int result;
	unsigned int temp;

	temp=*num;
	result=get_un_integer(row,col,len,&temp,(unsigned int) min,(unsigned int) max);
	if(result!=-1)
		*num=temp;
	return(result);
}
/*................................QUIT....................................*/
int download_now(void)
{
	char tab[2] = {9,0};
	char *msg[] = {"  DOWNLOAD CHANGES TO AGM?"};

	clearkbd();
	kybdstuf(tab);
	if(dlg_answ(0,3,24,-1,msg_fg,msg_bk,border_fg,border_bk,msg,1))
		return(NO);
	return(YES);


}
/*.........................................................................*/
void put_system_data(void)
{
	int r=4,c=17,f,b;

	f=dlgbox_fg;
	b=dlgbox_bk;

	curlocat(3,22);
	colrprtf(0,f,b,"%4.2f",HGM.rev);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-12s ",HGM.location);
	curlocat(r++,c);
	colrprtf(0,f,b,"%02u ",HGM.node);
	curlocat(r++,c);
	colrprtf(0,f,b,"%05u ",HGM.SN);
	curlocat(r++,c);

	colrprtf(0,f,b,"%02u ",HGM.num_zones);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-12s ",rezero_str[HGM.rezero_mode]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%03u min",HGM.zone_hold_min);
	curlocat(r++,c);
	colrprtf(0,f,b,"%02uPPM ",HGM.detection_limit);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-12s ",relay_parameter_str[HGM.audible_alarm_parameter]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-6s ",manual_auto_str[HGM.alarm_ack_mode]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%06.4fma/PPM ",HGM.loop2_factor);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-8s ",rs485_baud_str[HGM.RS485_baud]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%1u ",HGM.num_stop_bits);
	curlocat(r++,c);
	colrprtf(0,f,b,"%03u min ",HGM.service_mode_timeout);
}
/*.........................................................................*/
void put_status_data(void)
{
	int r=18,c=17,f,b;

	f=dlgbox_fg;
	b=dlgbox_bk;
	curlocat(r++,c);
	colrprtf(0,f,b,"%-14s",mode_str[HGM_status.mode]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-14s",state_str[HGM_status.state]);
	curlocat(r,c);
	colrprtf(0,f,b,"%02u",HGM_status.active_zone+1);
	curlocat(r++,c+11);
	colrprtf(0,f,b,"%02u",HGM_status.alarm_count);
	curlocat(r++,c);
	colrprtf(0,f,b,"%-14s",installed_str[HGM_status.loop_card_installed]);
	curlocat(r++,c);
	colrprtf(0,f,b,"%0x",HGM_status.fault.word);
}
/*.........................................................................*/
void put_system_box(void)
{
	int r=3,c=2,f,b;

	f=dlgbox_fg;
	b=dlgbox_bk;
	colrprtl("  A G M   REV 0.00 Ŀ",f,b,r++,c);
	colrprtl("     LOCATION:              ",f,b,r++,c);
	colrprtl("         NODE:              ",f,b,r++,c);
	colrprtl("           SN:              ",f,b,r++,c);
	colrprtl("      # ZONES:              ",f,b,r++,c);
	colrprtl("  REZERO MODE:              ",f,b,r++,c);
	colrprtl("    ZONE HOLD:              ",f,b,r++,c);
	colrprtl(" DETECT LIMIT:              ",f,b,r++,c);
	colrprtl("AUDIBLE ALARM:              ",f,b,r++,c);
	colrprtl("ALRM ACK MODE:              ",f,b,r++,c);
	colrprtl("LOOP 2 FACTOR:              ",f,b,r++,c);
	colrprtl("   RS485 BAUD:              ",f,b,r++,c);
	colrprtl("  # STOP BITS:              ",f,b,r++,c);
	colrprtl(" SERVICE TIME:              ",f,b,r++,c);
	colrprtl(" SYSTEM STATUS Ĵ",f,b,r++,c);
	colrprtl("         MODE:              ",f,b,r++,c);
	colrprtl("        STATE:              ",f,b,r++,c);
	colrprtl("  ACTIVE ZONE:    ALARMS:   ",f,b,r++,c);
	colrprtl("4-20mA OPTION:              ",f,b,r++,c);
	colrprtl("   FAULT WORD:              ",f,b,r++,c);
	colrprtl("",f,b,r++,c);

}

/*.........................................................................*/
void put_zone_box(void)
{
	int r=3,c=33,f,b;

	f=dlgbox_fg;
	b=dlgbox_bk;
	colrprtl("#LOCATIONALARMPPMPEAKTYPEĿ",f,b,r++,c);
	colrprtl("01                                    ",f,b,r++,c);
	colrprtl("02                                    ",f,b,r++,c);
	colrprtl("03                                    ",f,b,r++,c);
	colrprtl("04                                    ",f,b,r++,c);
	colrprtl("Ĵ",f,b,r++,c);
	colrprtl("05                                    ",f,b,r++,c);
	colrprtl("06                                    ",f,b,r++,c);
	colrprtl("07                                    ",f,b,r++,c);
	colrprtl("08                                    ",f,b,r++,c);
	colrprtl("Ĵ",f,b,r++,c);
	colrprtl("09                                    ",f,b,r++,c);
	colrprtl("10                                    ",f,b,r++,c);
	colrprtl("11                                    ",f,b,r++,c);
	colrprtl("12                                    ",f,b,r++,c);
	colrprtl("Ĵ",f,b,r++,c);
	colrprtl("13                                    ",f,b,r++,c);
	colrprtl("14                                    ",f,b,r++,c);
	colrprtl("15                                    ",f,b,r++,c);
	colrprtl("16                                    ",f,b,r++,c);
	colrprtl("",f,b,r++,c);

}
/*........................................................................*/
void put_zone_data(void)
{
	int n=0,z=0,r=4,c=37,f,b;

	f=dlgbox_fg;
	b=dlgbox_bk;

	put_zone_box();
	do
	{
		for(z=n;z<n+4;z++)
		{
			if(z<HGM.num_zones)
			{
				curlocat(r,c);
				if(zone[z].flow_OK)
					colrprtf(0,f,b,"%-12s",zone[z].location);
				else
					colrprtf(0,b,f,"NO FLOW!!");
				curlocat(r,c+13);
				colrprtf(0,f,b,"%-8s",alarm_type_str[zone[z].alarm]);
				if(zone[z].alarm!=NO_ALARM)
					paint(r,c+13,r,c+20,msg_fg,msg_bk);
				curlocat(r,c+22);
				colrprtf(0,f,b,"%04u",(unsigned int)zone[z].ppm);
				curlocat(r,c+27);
				colrprtf(0,f,b,"%04u",zone[z].peak_ppm);
				curlocat(r,c+32);
				colrprtf(0,f,b,"%-8s",refrigerant_name[zone[z].refrigerant_type]);
			}
			r++;
		}
		n+=4;
		r++;

	}while(n<=12);
}
/*.........................EDIT SYSTEM PARAMETERS...........................*/

void edit_system_parameters()
{
	DLG_PTR dlg_ptr;
	int f,b,something_changed=NO;
	unsigned int temp;
	int result,return_val,i,col=3,row=4,sub_return_val, a;
	double bl;
	char temp_str[16];

	char *main_sel[] = {"     LOCATION",
						"         NODE",
						"           SN",
						"      # ZONES",
						"  REZERO MODE",
						"    ZONE HOLD",
						" DETECT LIMIT",
						"AUDIBLE ALARM",
						"ALRM ACK MODE",
						"LOOP 2 FACTOR",
						"   RS485 BAUD",
						"  # STOP BITS",
						" SERVICE TIME"};

	put_system_data();
	f=dlgbox_fg;
	b=dlgbox_bk;
	mouse_off();
	do
	{
		set_shadow(0,WHITE,BLACK,0);
		return_val = smenu(row,col,main_sel,13,f+16,b,0,"",0,NULL);
		if(return_val>=0 && return_val<13)
		{
			something_changed=YES;
			switch(return_val)
			{
				case 0:
					i=get_string(row+return_val,col+14,12,HGM.location,"%-12s");
					break;
				case 1:
					i=get_un_char(row+return_val,col+14,2,&HGM.node,1,16);
					break;
				case 2:
					if(in_service_mode)
						i=get_un_integer(row+return_val,col+14,5,&HGM.SN,0,65535);
					break;
				case 3:
					i=get_un_char(row+return_val,col+14,2,&HGM.num_zones,4,16);
					break;
				case 4:
					set_shadow(1,WHITE,BLACK,0);
					i=smenu(row+return_val,col+14,rezero_str,2,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
					if(i!=-1)
						HGM.rezero_mode=i;
					set_shadow(0,WHITE,BLACK,0);
					break;

				case 5:
					i=get_un_integer(row+return_val,col+14,3,&HGM.zone_hold_min,1,999);
					break;
				case 6:
					i=get_un_char(row+return_val,col+14,2,&HGM.detection_limit,0,99);
					break;
				case 7:
					set_shadow(1,WHITE,BLACK,0);
					i=smenu(row+return_val,col+14,relay_parameter_str,7,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
					if(i!=-1)
						HGM.audible_alarm_parameter=i;
					set_shadow(0,WHITE,BLACK,0);
					break;
				case 8:
					set_shadow(1,WHITE,BLACK,0);
					i=smenu(row+return_val,col+14,manual_auto_str,2,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
					if(i!=-1)
						HGM.alarm_ack_mode=i;
					set_shadow(0,WHITE,BLACK,0);
					break;
				case 9:
					i=get_float(row+return_val,col+14,1,4,&HGM.loop2_factor,0.0001,1.0000,"%06.4f");
					break;
				case 10:
					set_shadow(1,WHITE,BLACK,0);
					i=scrlmenu(row+return_val,col+14,rs485_baud_str,14,8,dlgbox_fg,dlgbox_bk,-1,"",0,NULL);
					if(i!=-1)
						HGM.RS485_baud=i;
					set_shadow(0,WHITE,BLACK,0);
					break;
				case 11:
					i=get_un_integer(row+return_val,col+14,1,&HGM.num_stop_bits,1,2);
					break;
				case 12:
					i=get_un_integer(row+return_val,col+14,3,&HGM.service_mode_timeout,1,241);
					break;
			}
			put_system_data();
			mouse_on();
		}
	delay(200);
	} while(return_val != -1);
	set_shadow(1,WHITE,BLACK,0);
	put_system_data();
	if(something_changed && download_now() && send_system_data()==NO_ERROR && get_status_data()==NO_ERROR)
	{
		put_message(&dlg_ptr,"AGM SYSTEM DATA UPDATED",8,30);
		delay(3000);
		dlg_clos(dlg_ptr);
		put_status_data();
		put_zone_data();
	}
	mouse_on();
	kybdstuf("e");
	return;
}
/*...........................SELECT ZONE....................................*/
int select_zone(void)
{
	int r=4,c=34,f,b,ret,z;

	char *zone_sel[]={"01","02","03","04","",
					  "05","06","07","08","",
					  "09","10","11","12","",
					  "13","14","15","16"};

	f=dlgbox_fg+16;
	b=dlgbox_bk;
	set_shadow(0,WHITE,BLACK,0);
	ret=smenu(r,c,zone_sel,19,f,b,0,"",0,NULL);
	switch(ret)
	{
		case -1:z=-1;break;
		case 0:z=0;break;
		case 1:z=1;break;
		case 2:z=2;break;
		case 3:z=3;break;
		case 4:z=-1;break;
		case 5:z=4;break;
		case 6:z=5;break;
		case 7:z=6;break;
		case 8:z=7;break;
		case 9:z=-1;break;
		case 10:z=8;break;
		case 11:z=9;break;
		case 12:z=10;break;
		case 13:z=11;break;
		case 14:z=-1;break;
		case 15:z=12;break;
		case 16:z=13;break;
		case 17:z=14;break;
		case 18:z=15;break;
	}
	set_shadow(1,WHITE,BLACK,0);
	return(z);
}

//..........................................................................
void stuff_date_time_string(TIM *t,char *str)
{
	int i=19;
	if((10*t->year10+t->year1)<=98) // Y2K correction
		i=20;
	sprintf(str,"%1d%1d/%1d%1d/%d%1d%1d %1d%1d:%1d%1d:%1d%1d",
			 t->mon10,t->mon1,t->day10,t->day1,i,t->year10,t->year1,
			 t->hour10,t->hour1,t->min10,t->min1,t->sec10,t->sec1);
}
/*............................EDIT ZONE PARAMETERS...........................*/
void edit_zone_parameters(void)
{

	DLG_PTR dlg_ptr;
	int result,return_val,i,col=38,row=3,sub_return_val,z,f,b,something_changed=NO;
	char date_time_str[25];

	char *sel[] = {"    LOCATION",
				   " REFRIGERANT",
				   " degC @ ZONE",
				   " CURRENT PPM",
				   "    PEAK PPM",
				   "   PEAK TIME",
				   "  RESET PEAK",
				   "    DISTANCE",
				   "LOG INTERVAL",
				   "  LEAK LEVEL",
				   " SPILL LEVEL",
				   "  EVAC LEVEL"};


	put_zone_data();
	while((z=select_zone())!=-1)
	{
		f=pop_menu_fg;
		b=pop_menu_bk;
		stuff_date_time_string(&zone[z].peak_time,date_time_str);
		dlg_ptr = dlg_open(row,col,row+13,col+33,-1,f,b,f,b);
		for(i=0;i<12;i++)
		{
			dlg_loc(dlg_ptr,i,0);
			colrprtf(0,f,b,"%s",sel[i]);
		}
		curlocat(row,col+8);
		colrprtf(0,f,b,"ZONE #%d PARAMETERS",z+1);

		do
		{
			mouse_off();
			curlocat(row+1,col+14);
			colrprtf(0,f,b,"%-12s",zone[z].location);
			curlocat(row+2,col+14);
			colrprtf(0,f,b,"%-12s",refrigerant_name[zone[z].refrigerant_type]);
			curlocat(row+3,col+14);
			colrprtf(0,f,b,"%02d",zone[z].degC_at_zone);
			curlocat(row+4,col+14);
			colrprtf(0,f,b,"%04u",(unsigned int)zone[z].ppm);
			curlocat(row+5,col+14);
			colrprtf(0,f,b,"%-04u",zone[z].peak_ppm);
			curlocat(row+6,col+14);
			colrprtf(0,f,b,"%s",date_time_str);
			curlocat(row+8,col+14);
			colrprtf(0,f,b,"%03u ft",zone[z].distance);
			curlocat(row+9,col+14);
			colrprtf(0,f,b,"%04u min",zone[z].log_interval);
			curlocat(row+10,col+14);
			colrprtf(0,f,b,"%03u PPM",zone[z].leak_level);
			curlocat(row+11,col+14);
			colrprtf(0,f,b,"%03u PPM",zone[z].spill_level);
			curlocat(row+12,col+14);
			colrprtf(0,f,b,"%03u PPM",zone[z].evac_level);
			mouse_on();
			set_shadow(0,WHITE,BLACK,0);
			return_val = smenu(row+1,col+1,sel,12,f+16,b,0,"",0,NULL);
			set_shadow(1,WHITE,BLACK,0);
			if(return_val>=0 && return_val<12)
			{
				something_changed=YES;
				switch(return_val)
				{
					case 0:
						i=get_string(row+1+return_val,col+14,12,zone[z].location,"%-12s");
						break;
				   /*case 1:
						i=scrlmenu(row+3,col+14,refrigerant_name,MAX_GASES,10,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
						if(i!=-1)
							zone[z].refrigerant_type=i;
						break;
				   */
					case 2:
						i=get_integer(row+3,col+14,3,&zone[z].degC_at_zone,-20,55);
						break;
					case 6:
						zone[z].peak_ppm=0;
						break;
					case 7:
						i=get_un_integer(row+8,col+14,3,&zone[z].distance,0,500);
						break;
					case 8:
						i=get_un_integer(row+9,col+14,4,&zone[z].log_interval,0,9999);
						break;
					case 9:
						i=get_un_integer(row+10,col+14,3,&zone[z].leak_level,0,999);
						break;
					case 10:
						i=get_un_integer(row+11,col+14,3,&zone[z].spill_level,0,999);
						break;
					case 11:
						i=get_un_integer(row+12,col+14,3,&zone[z].evac_level,0,999);
						break;
				}
				mouse_on();
			}
		set_shadow(0,WHITE,BLACK,0);
		delay(200);
		}while(return_val!=-1);
		set_shadow(1,WHITE,BLACK,0);
		mouse_off();
		dlg_clos(dlg_ptr);
		put_zone_data();
	};

	if(something_changed && download_now() && send_zone_data()==NO_ERROR && get_status_data()==NO_ERROR)
	{
		put_message(&dlg_ptr,"AGM ZONE DATA UPDATED",8,30);
		delay(3000);
		dlg_clos(dlg_ptr);
		put_zone_data();
		put_status_data();
	}
	mouse_on();
	kybdstuf("e");
	return;
}


/*............................EDIT CAL PARAMETERS.........................*/
void edit_cal(void)
{

	DLG_PTR dlg_ptr;
	int result,return_val,i,col=20,row=8,sub_return_val,f,b,gas=R134A,something_changed=NO;
	char date_time_str[25];

	char *sel[] = {" REFRIGERANT",
				   "  CAL FACTOR",
				   "    GAS NAME",
				   "       CURVE"};


	f=pop_menu_fg;
	b=pop_menu_bk;
	dlg_ptr = dlg_open(row,col,row+5,col+27,-1,f,b,f,b);
	for(i=0;i<4;i++)
	{
		dlg_loc(dlg_ptr,i,0);
		colrprtf(0,f,b,"%s",sel[i]);
	}
	curlocat(row,col+5);
	colrprtf(0,f,b,"CAL DATA");

	do
	{
		mouse_off();
		curlocat(row+1,col+14);
		colrprtf(0,f,b,"%-12s ",refrigerant_name[gas]);
		curlocat(row+2,col+14);
		colrprtf(0,f,b,"%-06.4f ",HGM_cal.factor[gas]);
		curlocat(row+3,col+14);
		if(gas>=MAX_CAL_CURVES)
		{
			colrprtf(0,f,b,"%-12s ",HGM_cal.new_gas_name[gas-MAX_CAL_CURVES]);
			curlocat(row+4,col+14);
			colrprtf(0,f,b,"%-12s ",refrigerant_name[HGM_cal.curve[gas-MAX_CAL_CURVES]]);
		}
		else
		{
			colrprtf(0,f,b,"             ");
			curlocat(row+4,col+14);
			colrprtf(0,f,b,"             ");
		}

		mouse_on();
		set_shadow(0,WHITE,BLACK,0);
		return_val = smenu(row+1,col+1,sel,4,f,b,0,"",0,NULL);
		set_shadow(1,WHITE,BLACK,0);
		if(return_val>=0 && return_val<4)
		{
			something_changed=YES;
			switch(return_val)
			{
				/*case 0:
					i=scrlmenu(row+3,col+14,refrigerant_name,MAX_GASES,10,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
					if(i!=-1)
						gas=i;
					break;
				*/
				case 1:
					i=get_float(row+2,col+14,1,4,&HGM_cal.factor[gas],0.1,1.9999,"%06.4f");
					break;
				/*case 2:
					if(gas>=MAX_CAL_CURVES)
						i=get_string(row+3,col+14,12,HGM_cal.new_gas_name[gas-MAX_CAL_CURVES],"%-12s");
					break;
				case 3:
					if(gas>=MAX_CAL_CURVES)
					{
						i=scrlmenu(row+5,col+14,refrigerant_name,MAX_CAL_CURVES,10,pop_menu_fg,pop_menu_bk,-1,"",0,NULL);
						if(i!=-1)
							HGM_cal.curve[gas-MAX_CAL_CURVES]=i;
					}
					break;
				*/
			}
			mouse_on();
		}
	set_shadow(0,WHITE,BLACK,0);
	delay(200);
	} while(return_val != -1);
	set_shadow(1,WHITE,BLACK,0);
	dlg_clos(dlg_ptr);
	if(something_changed && download_now() && send_cal_data()==NO_ERROR && get_status_data()==NO_ERROR)
	{
		put_message(&dlg_ptr,"AGM CAL DATA UPDATED",8,30);
		delay(3000);
		dlg_clos(dlg_ptr);
		put_status_data();
	}
	kybdstuf("e");
	return;
}

/*........................................................................*/
void put_fault_log(void)
{

	DLG_PTR dlg_ptr;
	int result,i,key,col=22,row=3,r,c,f,b;
	char date_time_str[25];


	f=pop_menu_fg;
	b=pop_menu_bk;
	dlg_ptr = dlg_open(row,col,row+13,col+39,-1,f,b,f,b);

	r=row+1;
	c=col+1;
	colrprtl("        BOX TEMP",f,b,r++,c);
	colrprtl("      BENCH TEMP",f,b,r++,c);
	colrprtl(" PRESSURE SENSOR",f,b,r++,c);
	colrprtl("                ",f,b,r++,c);
	colrprtl("       LOOP OPEN",f,b,r++,c);
	colrprtl("   CONFIGURATION",f,b,r++,c);
	colrprtl("     A/D TRIGGER",f,b,r++,c);
	colrprtl("       ZONE FLOW",f,b,r++,c);
	colrprtl("      PURGE FLOW",f,b,r++,c);
	colrprtl("         NO FLOW",f,b,r++,c);
	colrprtl("ZERO VOLTAGE TOL",f,b,r++,c);
	colrprtl("        CLIPPING",f,b,r++,c);
	for(i=0;i<20;i++)
	{
		curlocat(row+1,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.box_T?'':'');
		curlocat(row+2,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.bench_T?'':'');
		curlocat(row+3,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.P?'':'');
		curlocat(row+4,col+18+i);
		/*colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.RS485?'':'');*/
		curlocat(row+5,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.loops?'':'');
		curlocat(row+6,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.config?'':'');
		curlocat(row+7,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.trigger?'':'');
		curlocat(row+8,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.zone_flow?'':'');
		curlocat(row+9,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.purge_flow?'':'');
		curlocat(row+10,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.no_flow?'':'');
		curlocat(row+11,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.zero?'':'');
		curlocat(row+12,col+18+i);
		colrprtf(0,f+16,b,"%c",HGM_fault_log.fault[i].flags.clipping?'':'');
	}
	c=HGM_fault_log.ptr;
	paint(row+1,col+18+c,row+12,col+18+c,b,f);
	stuff_date_time_string(&HGM_fault_log.time[c],date_time_str);
	curlocat(row,col+8);
	colrprtf(0,f,b,"FAULTS AT %-20s",date_time_str);
	do
	{
		i=getkey(&key);
		if(i==1)key=-key;
		switch(key)
		{
			case CURLF:
			case PGUP:
					paint(row+1,col+18+c,row+12,col+18+c,f+16,b);
					if(c>0)
						c--;
					  else
						c=FAULT_LOG_LENGTH-1;
					paint(row+1,col+18+c,row+12,col+18+c,b,f);
					stuff_date_time_string(&HGM_fault_log.time[c],date_time_str);
					curlocat(row,col+18);
					colrprtf(0,f,b,"%-20s",date_time_str);
					break;
			case CURRT:
			case PGDN:
					paint(row+1,col+18+c,row+12,col+18+c,f+16,b);
					if(c<FAULT_LOG_LENGTH-1)
						c++;
					else
						c=0;
					paint(row+1,col+18+c,row+12,col+18+c,b,f);
					stuff_date_time_string(&HGM_fault_log.time[c],date_time_str);
					curlocat(row,col+18);
					colrprtf(0,f,b,"%-20s",date_time_str);
					break;
		}
	}
	while(key!=ESCAPE);
	set_shadow(1,WHITE,BLACK,0);
	mouse_off();
	dlg_clos(dlg_ptr);
	mouse_on();
	kybdstuf("d");
	return;

}
/*........................................................................*/
void put_alarm_log(void)
{

	DLG_PTR dlg_ptr;
	int result,i,z,key,col=22,row=3,r,c,f,b;
	char date_time_str[25];
	char alarm_char[4]={'','L','S','E'};


	f=pop_menu_fg;
	b=pop_menu_bk;
	dlg_ptr = dlg_open(row,col,row+17,col+38,-1,f,b,f,b);

	r=row+1;
	c=col+1;
	for(z=0;z<16;z++)
	{
		curlocat(r++,c);
		colrprtf(0,f,b,"%12.12s",zone[z].location);
	}
	for(i=0;i<20;i++)
		for(z=0;z<16;z++)
		{
			curlocat(row+1+z,col+18+i);
			colrprtf(0,f+16,b,"%c",alarm_char[HGM_alarm_log.event[i][z]]);
		}
	c=HGM_alarm_log.ptr;
	paint(row+1,col+18+c,row+16,col+18+c,b,f);
	stuff_date_time_string(&HGM_alarm_log.time[c],date_time_str);
	curlocat(row,col+8);
	colrprtf(0,f,b,"ALARMS AT %-20s",date_time_str);
	do
	{
		i=getkey(&key);
		if(i==1)key=-key;
		switch(key)
		{
			case CURLF:
			case PGUP:
					paint(row+1,col+18+c,row+16,col+18+c,f+16,b);
					if(c>0)
						c--;
					  else
						c=FAULT_LOG_LENGTH-1;
					paint(row+1,col+18+c,row+16,col+18+c,b,f);
					stuff_date_time_string(&HGM_alarm_log.time[c],date_time_str);
					curlocat(row,col+18);
					colrprtf(0,f,b,"%-20s",date_time_str);
					break;
			case CURRT:
			case PGDN:
					paint(row+1,col+18+c,row+16,col+18+c,f+16,b);
					if(c<FAULT_LOG_LENGTH-1)
						c++;
					else
						c=0;
					paint(row+1,col+18+c,row+16,col+18+c,b,f);
					stuff_date_time_string(&HGM_alarm_log.time[c],date_time_str);
					curlocat(row,col+18);
					colrprtf(0,f,b,"%-20s",date_time_str);
					break;
		}
	}
	while(key!=ESCAPE);
	set_shadow(1,WHITE,BLACK,0);
	mouse_off();
	dlg_clos(dlg_ptr);
	mouse_on();
	kybdstuf("h");
	return;

}

//..........................................................................
void show_sensors(void)
{
	DLG_PTR dlg_ptr;
	int result,i,key,col=26,row=3,r,c,f,b;

	f=pop_menu_fg;
	b=pop_menu_bk;
	dlg_ptr = dlg_open(row,col,row+14,col+36,-1,f,b,f,b);
	curlocat(row,col+4);
	colrprtf(0,f,b,"PRESS ENTER TO UPDATE");
	do
	{

		curlocat(row+1,col+1);
		colrprtf(0,f,b," DETECTOR=%06.4f VPKPK NOISE=%06.4f",sensor.pkpk,sensor.noise);
		curlocat(row+2,col+1);
		colrprtf(0,f,b," DETECTOR=%06.4f VPKPK AVE",sensor.ave_pkpk);
		curlocat(row+3,col+1);
		colrprtf(0,f,b,"     ZERO=%06.4f VPKPK",sensor.zero_pkpk);
		curlocat(row+4,col+1);
		colrprtf(0,f,b,"   AVE AU=%07.5f",sensor.ave_AU);
		curlocat(row+5,col+1);
		colrprtf(0,f,b," UMOLES/L=%+06.3fB %+06.3fAMB",sensor.bench_uMl,sensor.ambient_uMl);
		curlocat(row+6,col+1);
		colrprtf(0,f,b,"      PPM=%+06.1fB %+06.1fSTP",sensor.bench_ppm,sensor.STP_ppm);
		curlocat(row+7,col+1);
		colrprtf(0,f,b,"   ZERO T=%05.2fC BENCH",sensor.bench_zero_T);
		curlocat(row+8,col+1);
		colrprtf(0,f,b,"   ZERO T=%05.2fC BOX",sensor.box_zero_T);
		curlocat(row+9,col+1);
		colrprtf(0,f,b,"  BENCH T=%05.2fC    %05.3fV",sensor.bench_T,sensor.bench_T_volts);
		curlocat(row+10,col+1);
		colrprtf(0,f,b,"    BOX T=%05.2fC    %05.3fV",sensor.box_T,sensor.box_T_volts);
		curlocat(row+11,col+1);
		colrprtf(0,f,b," PRESSURE=%05.2fPSIA %05.3fV",sensor.P,sensor.P_volts);
		curlocat(row+12,col+1);
		colrprtf(0,f,b,"   VACUUM=%05.2fPSIA",sensor.vacuum_P);
		curlocat(row+13,col+1);
		colrprtf(0,f,b,"  AMBIENT=%05.2fPSIA",sensor.ambient_P);
		getkey(&key);
		if(key==RETURN)
		{
			result=get_sensor_data();
			if(result!=NO_ERROR)
			{
				com_error(result);
				dlg_clos(dlg_ptr);
				kybdstuf("d");
				return;
			}
		}
	}while(result==NO_ERROR&&key!=ESCAPE);
	dlg_clos(dlg_ptr);
	kybdstuf("d");
	return;
}


//..........................................................................
void log_sensors(void)
{
	DLG_PTR dlg_ptr;
	int result,i,key,col=10,row=3,r,c,f,b;
	FILE *logfile=NULL;

	struct date d;
	struct time t;

	if((logfile=fopen("cal_log.txt","at"))!=NULL)
	{
		fprintf(logfile,"DATE TIME,#1 BENCH P,#1 AMB PSIA,#1 BENCH T,#1 AU,#1 um/L,#1 PPM,");
		fprintf(logfile,"#2 BENCH P,#2 AMB PSIA,#2 BENCH T,#2 AU,#2 um/L,#2 PPM,");
		fprintf(logfile,"#3 BENCH P,#3 AMB PSIA,#3 BENCH T,#3 AU,#3 um/L,#3 PPM,");
		fprintf(logfile,"#4 BENCH P,#4 AMB PSIA,#4 BENCH T,#4 AU,#4 um/L,#4 PPM\n");
		fclose(logfile);
	}

	f=pop_menu_fg;
	b=pop_menu_bk;
	dlg_ptr = dlg_open(row,col,row+12,col+55,-1,f,b,f,b);
	curlocat(row,col+4);
	colrprtf(0,f,b,"LOGGING TO CAL_LOG.TXT (ESC to stop)");

	do
	{

		inkey(&key);

		send_RTU_query(port,1,READ_HOLDING_REG,SENSOR_DATA_REG,(unsigned char*)&unit[0],sizeof(HGM_SENSOR_DATA));
		send_RTU_query(port,2,READ_HOLDING_REG,SENSOR_DATA_REG,(unsigned char*)&unit[1],sizeof(HGM_SENSOR_DATA));
		send_RTU_query(port,3,READ_HOLDING_REG,SENSOR_DATA_REG,(unsigned char*)&unit[2],sizeof(HGM_SENSOR_DATA));
		send_RTU_query(port,4,READ_HOLDING_REG,SENSOR_DATA_REG,(unsigned char*)&unit[3],sizeof(HGM_SENSOR_DATA));
		if(key==13 && (logfile=fopen("cal_log.txt","at"))!=NULL)
		{
			gettime(&t);
			getdate(&d);
			fprintf(logfile,"%d/%d/%d %d:%d:%d,",d.da_mon,d.da_day,d.da_year,t.ti_hour,t.ti_min,t.ti_sec);
			fprintf(logfile,"%5.2f,%5.2f,%5.2f,%7.5f,%6.3f,%.1f,",
						unit[0].P,unit[0].ambient_P,unit[0].bench_T,unit[0].ave_AU,unit[0].bench_uMl,unit[0].bench_ppm);
			fprintf(logfile,"%5.2f,%5.2f,%5.2f,%7.5f,%6.3f,%.1f,",
						unit[1].P,unit[1].ambient_P,unit[1].bench_T,unit[1].ave_AU,unit[1].bench_uMl,unit[1].bench_ppm);
			fprintf(logfile,"%5.2f,%5.2f,%5.2f,%7.5f,%6.3f,%.1f,",
						unit[2].P,unit[2].ambient_P,unit[2].bench_T,unit[2].ave_AU,unit[2].bench_uMl,unit[2].bench_ppm);
			fprintf(logfile,"%5.2f,%5.2f,%5.2f,%7.5f,%6.3f,%.1f\n",
						unit[3].P,unit[3].ambient_P,unit[3].bench_T,unit[3].ave_AU,unit[3].bench_uMl,unit[3].bench_ppm);
			fclose(logfile);
			good_beep();
			good_beep();
			key=0;
		}

		curlocat(row+1,col+1);
		colrprtf(0,f,b," DETECTOR=%06.4f %06.4f %06.4f %06.4f ",unit[0].pkpk,unit[1].pkpk,unit[2].pkpk,unit[3].pkpk);
		curlocat(row+2,col+1);
		colrprtf(0,f,b," DETECTOR=%06.4f %06.4f %06.4f %06.4f AVE",unit[0].ave_pkpk,unit[1].ave_pkpk,unit[2].ave_pkpk,unit[3].ave_pkpk);
		curlocat(row+3,col+1);
		colrprtf(0,f,b,"     ZERO=%06.4f %06.4f %06.4f %06.4f ",unit[0].zero_pkpk,unit[1].zero_pkpk,unit[2].zero_pkpk,unit[3].zero_pkpk);
		curlocat(row+4,col+1);
		colrprtf(0,f,b,"   AVE AU=%+07.5f %+07.5f %+07.5f %+07.5f ",unit[0].ave_AU,unit[1].ave_AU,unit[2].ave_AU,unit[3].ave_AU);
		curlocat(row+5,col+1);
		colrprtf(0,f,b," UMOLES/L=%+06.3f %+06.3f %+06.3f %+06.3f AMB",unit[0].ambient_uMl,unit[1].ambient_uMl,unit[2].ambient_uMl,unit[3].ambient_uMl);
		curlocat(row+6,col+1);
		colrprtf(0,f,b,"      PPM=%+06.1f %+06.1f %+06.1f %+06.1f ",unit[0].bench_ppm,unit[1].bench_ppm,unit[2].bench_ppm,unit[3].bench_ppm);
		curlocat(row+7,col+1);
		colrprtf(0,f,b," PRESSURE=%05.2f %05.2f %05.2f %05.2f PSIA",unit[0].P,unit[1].P,unit[2].P,unit[3].P);
		curlocat(row+8,col+1);
		colrprtf(0,f,b,"   VACUUM=%05.2f %05.2f %05.2f %05.2f PSIA",unit[0].vacuum_P,unit[1].vacuum_P,unit[2].vacuum_P,unit[3].vacuum_P);
		curlocat(row+9,col+1);
		colrprtf(0,f,b,"  AMBIENT=%05.2f %05.2f %05.2f %05.2f PSIA",unit[0].ambient_P,unit[1].ambient_P,unit[2].ambient_P,unit[3].ambient_P);
		beep();
		delay(5000);

		if(key=='z' || key=='Z')
		{
			HGM_status.mode=NORMAL_MODE; // release service mode
			HGM_status.state=ZEROING;
			send_RTU_query(port,1,PRESET_MULTI_REG,RELEASE_SERVICE_REG,(unsigned char*)&HGM_status,sizeof(HGM_STATUS_DATA));
			send_RTU_query(port,2,PRESET_MULTI_REG,RELEASE_SERVICE_REG,(unsigned char*)&HGM_status,sizeof(HGM_STATUS_DATA));
			send_RTU_query(port,3,PRESET_MULTI_REG,RELEASE_SERVICE_REG,(unsigned char*)&HGM_status,sizeof(HGM_STATUS_DATA));
			send_RTU_query(port,4,PRESET_MULTI_REG,RELEASE_SERVICE_REG,(unsigned char*)&HGM_status,sizeof(HGM_STATUS_DATA));
			key=0;
		}
	}while(key!=ESCAPE);
	dlg_clos(dlg_ptr);
	kybdstuf("d");
	return;
}


/*.........................................................................*/
void zone_hold(void)
{
	DLG_PTR dlg_ptr;
	int z,result;

	z=select_zone();
	if(z==-1)return;

	if(get_status_data()==NO_ERROR)
	{
		HGM_status.mode=ZONE_HOLD_MODE; // new hold command
		HGM_status.active_zone=z;
		if(send_zone_hold()==NO_ERROR)
		{
			put_message(&dlg_ptr,"HOLDING ZONE",8,30);
			delay(3000);
			dlg_clos(dlg_ptr);
			put_zone_data();
			put_status_data();
		}
	}
}
/*.........................................................................*/
void release_hold(void)
{
	DLG_PTR dlg_ptr;

	HGM_status.mode=NORMAL_MODE; // release the hold
	if(send_release_hold()==NO_ERROR)
	{
		put_message(&dlg_ptr,"HOLD RELEASED",8,30);
		delay(3000);
		dlg_clos(dlg_ptr);
		put_zone_data();
		put_status_data();
	}
}
/*.........................................................................*/
void request_service_mode(void)
{
	DLG_PTR dlg_ptr;
	int z,result;

	if(get_status_data()==NO_ERROR)
	{
		HGM_status.mode=SERVICE_MODE; // new hold command
		HGM_status.state=IDLE;
		if(send_service_mode_request()==NO_ERROR)
		{
			put_message(&dlg_ptr,"SERVICE MODE ENTERED",8,30);
			delay(3000);
			dlg_clos(dlg_ptr);
			put_status_data();
		}
	}
}
/*.........................................................................*/
void release_service_mode(void)
{
	DLG_PTR dlg_ptr;

	if(get_status_data()==NO_ERROR)
	{
		HGM_status.mode=NORMAL_MODE; // release service mode
		HGM_status.state=ZEROING;
		if(send_service_mode_release()==NO_ERROR)
		{
			put_message(&dlg_ptr,"SERVICE MODE RELEASED",8,30);
			delay(3000);
			dlg_clos(dlg_ptr);
			put_status_data();
		}
	}
}
/*.........................................................................*/
void get_trend(void)
{
	DLG_PTR dlg_ptr;
	int z,result,count=0;
	char time_str[25];
	unsigned int i;

	z=select_zone();
	if(z==-1)return;

	if(get_trend_data((unsigned)z)==NO_ERROR)
	{
		if(zone_log.index!=0)
			i=zone_log.index-1;
		else
			i=99;
		do
		{
			stuff_date_time_string(&zone_log.time[i],time_str);
			sprintf(trend_string[count],"%s,%5u",time_str,zone_log.ppm[i]);
			trend_string_ptr[count]=&trend_string[count];
			if(i>0)
				i--;
			else
				i=99;
			count++;
		}while(count<100);
		sprintf(time_str,"ZONE %02u TREND DATA",z+1);
		i=scrlmenu(3,25,trend_string_ptr,100,20,pop_menu_fg,pop_menu_bk,-1,time_str,0,NULL);
		save_trend();
	}
}

/*.........................................................................*/
void set_HGM_clock(void)
{
	TRANSMIT_TIME_TYPE t;
	DLG_PTR dlg_ptr;
	char t_str[25];

	sysdate(t_str,1);
	t.year10=t_str[0]-48;
	t.year1=t_str[1]-48;
	t.mon10=t_str[2]-48;
	t.mon1=t_str[3]-48;
	t.day10=t_str[4]-48;
	t.day1=t_str[5]-48;
	systime(t_str,3);
	t.hour10=t_str[0]-48;
	t.hour1=t_str[1]-48;
	t.min10=t_str[2]-48;
	t.min1=t_str[3]-48;
	t.sec10=t_str[4]-48;
	t.sec1=t_str[5]-48;

	if(send_HGM_time(&t)==NO_ERROR)
	{
		put_message(&dlg_ptr,"AGM DATE & TIME SET",8,30);
		delay(3000);
		dlg_clos(dlg_ptr);
	}
}

/*.........................................................................*/
void ack_alarm(void)
{
	DLG_PTR dlg_ptr;
	int z,result;



	if(get_zone_data()==NO_ERROR)
	{
		z=select_zone();
		if(z==-1 || zone[z].alarm==NO_ALARM)return;
		zone[z].alarm=NO_ALARM;/* silence the alarm */
		if(send_single_zone_data(z)==NO_ERROR && get_status_data()==NO_ERROR)
		{
			put_message(&dlg_ptr,"ALARM ACKNOWLEGED",8,30);
			delay(3000);
			dlg_clos(dlg_ptr);
			put_zone_data();
			put_status_data();
		}
	}
}