/***************************************************************************
	(C) COPYRIGHT 1999,2000,2001 by JANOS TECHNOLOGY INC. Townshend Vermont
	PROPRIETARY: Source code, algorithms and data contained in this
				 file may not be used, reproduced or transmitted
				 without written permission of JANOS TECHNOLOGY INC.

		 PROJECT: HGM300
		  AUTHOR: Chris Prozzo

***************************************************************************/


#include <bios.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <string.h>
#include <conio.h>


#include "culproto.h"
#include "pc2hgm.h"


/*..........................LOCAL FUNCTIONS...............................*/


void clock();
int check_clock();

/*........................LOCAL VARIABLES.................................*/

int in_exit;

/*........................EXTERNAL VARIABLES..............................*/

extern int cul_mouse_icf;

/*.........................CHR_EXIT IDLE PROCESSING........................*/

int chr_exit(int *key)
{

	if (in_exit == YES)
		return(*key);
	in_exit = YES;
	clock();

	in_exit = NO;
	return(*key);
}



/*........................EXTENDED KEY IDLE PROCESSING......................*/

int ext_exit(int *key)
{
	char stuf[2] = {ESCAPE,NULL};

	if (in_exit == YES)
		return(*key);
	in_exit = YES;


	in_exit = NO;
	return(*key);
}

/*......................FUNCTION KEY IDLE PROCESSING.......................*/

int f1_exit(int *key)
{
	int i;
	*key = 0;

	return(*key);
}


int f2_exit(int *key)
{
	char stuf[5] = {ESCAPE,'f','s',NULL};

	if(in_exit == YES)
		return(*key);
	in_exit = YES;
	in_exit = NO;
	return(*key);
}

int f3_exit(int *key)
{
	char stuf[5] = {ESCAPE,'f','o',NULL};

	if(in_exit == YES)
		return(*key);
	in_exit = YES;
	in_exit = NO;
	return(*key);
}

/*...........................PUT UP MESSAGE BOX............................*/

int put_message(DLG_PTR *box_ptr,char *message,int row,int col)
{
	int len,return_val;

	len = strlen(message);
	*box_ptr = dlg_open(row,col,row+2,col+1+len,-1,msg_fg,msg_bk,border_fg,border_bk);
	if (*box_ptr == NULL)
		return(FAILED);
	dlg_loc(*box_ptr,0,0);
	dlg_prnt(*box_ptr,message,msg_fg,msg_bk,0);
	return(SUCCESS);
}

/*..............................ERROR BEEP.................................*/

void error_beep()
{

	if (sound_status == ON)
		sound1(800,5);

	return;
}
/*...............................GOOD BEEP.................................*/
void good_beep()
{

	if (sound_status == ON)
		sound1(2500,3);

	return;
}


/*..............................CLOCK......................................*/
void clock()
{
	int hr,min,sec,hsec;
	int col,row;
	static cnt;

	sysitime(&hr,&min,&sec,&hsec);
	if (cnt != min)
	{
		cnt = min;
		cur_time_str[0] = ' ';
		strtime(cur_time_str,hr,min,sec,0,18);
		curget(&row,&col);
		colrprtl(cur_time_str,title_fg,title_bk,0,70);
		sysdate(cur_date_str,7);
		colrprtl(cur_date_str,title_fg,title_bk,0,0);
		curlocat(row,col);
	}
	return;
}
/*.......................CHECK CLOCK.......................................*/

int check_clock()
{

	int day,month,year;

	sysidate(&year,&month,&day);
	if(year < 1990)
		return(FAILED);
	return(SUCCESS);

}
/*...........................MOUSE ON....................................*/
void mouse_on()
{
	if(mouse && cul_mouse_icf==-1)m_curon();
	return;
}
/*...........................MOUSE OFF....................................*/
void mouse_off()
{
	if(mouse && cul_mouse_icf==0)m_curoff();
	return;
}
